require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/admin/admin_configs', type: :request do
  # Admin::AdminConfig. As you add validations to Admin::AdminConfig, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {} }
  let(:invalid_attributes) { {connexion: nil} }

  let(:user) { FactoryBot.create(:user) }
  before :each do
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      admin_config = Admin::AdminConfig.create! valid_attributes
      get admin_admin_configs_url
      # binding.pry
      expect(response).to redirect_to(edit_admin_admin_config_url(admin_config))
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      admin_config = Admin::AdminConfig.create! valid_attributes
      get edit_admin_admin_config_url(admin_config)
      expect(response).to be_successful
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) do
        { connexions: { database_login: 'false',
                        database_signup: 'false',
                        ldap_login: 'false' }
        }
      end

      it 'updates the requested admin_config' do
        admin_config = Admin::AdminConfig.create! valid_attributes
        patch admin_admin_config_url(admin_config), params: { admin_admin_config: new_attributes }
        admin_config.reload

        expect(admin_config.connexions[:database_login]).to eq 'false'
        expect(admin_config.connexions[:database_signup]).to eq 'false'
        expect(admin_config.connexions[:ldap_login]).to eq 'false'
      end

      it 'redirects to the admin_config' do
        admin_config = Admin::AdminConfig.create! valid_attributes
        patch admin_admin_config_url(admin_config), params: { admin_admin_config: new_attributes }
        admin_config.reload
        expect(response).to redirect_to(admin_admin_configs_url)
      end
    end

    # context 'with invalid parameters' do
    #   it 'renders a successful response (i.e. to display the edit template)' do
    #     admin_config = Admin::AdminConfig.create! valid_attributes
    #     patch admin_admin_config_url(admin_config), params: { admin_admin_config: invalid_attributes }
    #     expect(response).to be_successful
    #   end
    # end
  end
end
